package com.izouma.awesomeadmin.web;

import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.CityInfo;
import com.izouma.awesomeadmin.service.CityInfoService;
import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
*  controller类
*/
@Controller
@RequestMapping("/cityInfo")
public class CityInfoController {

    @Autowired
    private CityInfoService cityInfoService;

    /**
    * <p>获取全部记录。</p>
    */
    //@RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(CityInfo record) {
        List<CityInfo> pp = cityInfoService.getCityInfoList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getCityInfo", method = RequestMethod.GET)
    @ResponseBody
    public Result getCityInfo(@RequestParam(required = false, value = "id") String id) {
        CityInfo data = cityInfoService.getCityInfoById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(CityInfo record) {
        CityInfo data = cityInfoService.getCityInfo(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, CityInfo record) {
        Map<String, Object> result = new HashMap<>();

        List<CityInfo> pp =cityInfoService.getCityInfoByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(CityInfo record) {
        boolean num = cityInfoService.createCityInfo(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateCityInfo(CityInfo record) {
        boolean num = cityInfoService.updateCityInfo(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteCityInfo(CityInfo record) {

        boolean num = cityInfoService.deleteCityInfo(record);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, CityInfo record) throws Exception {

    List<CityInfo> cityInfos = cityInfoService.getCityInfoList(record);


        String sheetName = "city_info";
        String titleName = "城市信息数据表";
        String fileName = "城市信息表";
        int columnNumber = 13;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "ID" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "CODE" ,   "城市名" ,   "备注" ,   "排序" ,   "热门" ,   "最近访问时间" ,   "拼音"  };
        String[][] dataList = new String[cityInfos.size()][13];

        for (int i = 0; i < cityInfos.size(); i++) {

                        dataList[i][0] = String.valueOf(cityInfos.get(i).getId());
                        dataList[i][1] = String.valueOf(cityInfos.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(cityInfos.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(cityInfos.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(cityInfos.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(cityInfos.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(cityInfos.get(i).getCode());
                        dataList[i][7] = String.valueOf(cityInfos.get(i).getCityName());
                        dataList[i][8] = String.valueOf(cityInfos.get(i).getRemark());
                        dataList[i][9] = String.valueOf(cityInfos.get(i).getRank());
                        dataList[i][10] = String.valueOf(cityInfos.get(i).getHotFlag());
                        dataList[i][11] = String.valueOf(cityInfos.get(i).getLatestTime());
                        dataList[i][12] = String.valueOf(cityInfos.get(i).getPinYin());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

